apiVersion: apps/v1
kind: Deployment
metadata:
  name: $APP_IMAGE-app
spec:
  replicas: $REPLICAS
  selector:
    matchLabels:
      app: $APP_IMAGE-app
  template:
    metadata:
      annotations:
        config.linkerd.io/proxy-cpu-limit: 2000m
        config.linkerd.io/proxy-cpu-request: 2000m
        config.linkerd.io/proxy-memory-limit: 512mi
        config.linkerd.io/proxy-memory-request: 512mi
        linkerd.io/inject: ingress
      labels:
        app: $APP_IMAGE-app

    spec:
      containers:
      - image: $APP_IMAGE
        imagePullPolicy: IfNotPresent
        name: $APP_IMAGE
        ports:
        - containerPort: 3000
          name: grpc
        resources:
          limits:
            cpu: 1000m
            memory: 256Mi
---
apiVersion: v1
kind: Service
metadata:
  name: $APP_IMAGE-svc
spec:
  selector:
    app: $APP_IMAGE-app
  type: NodePort
  ports:
  - name: grpc
    port: 3000
    targetPort: 3000
---
apiVersion: networking.k8s.io/v1beta1
kind: Ingress
metadata:
  name: $APP_IMAGE-ingress
  annotations:
    kubernetes.io/ingress.class: "nginx"
    nginx.ingress.kubernetes.io/backend-protocol: GRPC
spec:
  tls:
    - hosts:
      # Certificate domain name
      - $DOMAIN
      secretName: $APP_IMAGE-secret
  rules:
  # gRPC service domain name
  - host: $DOMAIN
    http:
      paths:
      - path: /
        backend:
          serviceName: $APP_IMAGE-svc
          servicePort: 3000
